# LEGO type:standard slot:5 autostart

import os, sys

from spike import PrimeHub, LightMatrix, Button, StatusLight, ForceSensor, MotionSensor, Speaker, ColorSensor, App, DistanceSensor, Motor, MotorPair
from spike.control import wait_for_seconds, wait_until, Timer
from hub import battery
from math import *

############## Allgemein: Prüfe Batteriezustand ###############################
if battery.voltage() < 8000: #set threshold for battery level
    print("Spannung der Batterie zu niedrig: " + str(battery.voltage()) + " \n"
        + "--------------------------------------- \n "
        + "#### UNBEDINGT ROBOTER AUFLADEN !!! #### \n"
        + "#### SONST KOMMT MARKUS OPTITZ !!!! #### \n"
        + "---------------------------------------- \n")
else:
    print("Spannung der Batterie " + str(battery.voltage()) + "\n")
################################################################################

############################## NICHT ÄNDERN ###############################
def importFile(slotid=0, precompiled=False, module_name='importFile'):
    print("##### START # IMPORTING CODE FROM SLOT "+str(slotid)+" ##############")
    import os, sys
    suffix = ".py"
    if precompiled:
        suffix = ".mpy"
    with open("/projects/.slots","rt") as f:
        slots = eval(str(f.read()))
        print(slots)
    print(os.listdir("/projects/"+str(slots[slotid]["id"])))
    with open("/projects/"+str(slots[slotid]["id"])+"/__init__"+suffix,"rb") as f:
        print("trying to read import program")
        program = f.read()
        print(program)
    try:
        os.remove("/"+module_name+suffix)
    except:
        pass
    with open("/"+module_name+suffix,"w+") as f:
        print("trying to write import program")
        f.write(program)
    if (module_name in sys.modules):
        del sys.modules[module_name]
    #exec("from " + module_name + " import *")
    print("##### END # IMPORTING CODE FROM SLOT "+str(slotid)+" ##############")
#####################################################################################


################ Importiere Code aus andere Dateien #################################

# Importiere Code aus der Datei "iqrobot.py"
# Dateiname und Modulname sollten gleich sein, dann kann man Code Completion nutzen
importFile(slotid=6, precompiled=True, module_name="iqrobot")
import iqrobot as iq
print(iq.HELLO) 

# Definiere an welchen Ports die Sensoren angeschlossen sind 
COLOR_SENSOR_PORT = 'E'
LEFT_MOTOR_PORT = 'A'
RIGHT_MOTOR_PORT = 'B'
STICK_MOTOR_PORT = 'C'
GABEL_MOTOR_PORT = 'D'

# Initialisieren des Hubs, der Aktoren und Sensoren
hub = PrimeHub()

# Initialisiere Robot Klasse mit unseren Funktionen
iqRobot: iq.IQRobot = iq.IQRobot(hub, LEFT_MOTOR_PORT, RIGHT_MOTOR_PORT, COLOR_SENSOR_PORT, STICK_MOTOR_PORT, GABEL_MOTOR_PORT)

'''
while(True):
    print('DIE FARBE IST ', iqRobot.colorSensor.get_color())
    if (iqRobot.colorSensor.get_color() == "cyan"):
        iqRobot.driveForward_for_sec(1)
        print('Blau du Affe')
    elif(iqRobot.colorSensor.get_red() == "red"):
        iqRobot.driveForward_for_sec(1)
        print('Rot du Affe')
    else:
        print('Keine Farbe!')
'''

iqRobot.moveGabel(50)







